var searchURL = "http://www.";
var debugMode = 2;

// Write to the debug div when in Safari.
// Send a simple alert to Console when in Dashboard.
function DEBUG(str) {
	if (debugMode) {
		if (window.widget || debugMode == 2) {
			alert(str);
		}
	}
}


if (window.widget) {
    widget.onshow = onshow;
}



function DashboardSubmit(form, url)
{
	DEBUG("DashboardSubmit");
	DEBUG("form.name=" + form.name);
	DEBUG("form.method=" + form.method);
	DEBUG("form.action=" + form.action);
	
	// ???? for some reason we cant read the form.action property, so force the caller to pass it in!!
	//var url = form.action;
	// ???? for some reason we cant read the form.action property, so force the caller to pass it in!!
	
	for (var i=0; i<form.elements.length; i++)
	{
		DEBUG("   name=" + form.elements[i].name + " value='" + form.elements[i].value + "'");
		
		if (form.elements[i].value != " ") // openURL does not like spaces??...
		{
			url += (i==0 ? "?" : "&") + form.elements[i].name + "=" + escape(form.elements[i].value);
		}
	}
	
	DEBUG("URL=" + url);
	window.widget.openURL(url);
	return false;
}
function load()
{
	var helloText = document.getElementById("helloText");
	helloText.innerText = getLocalizedString(helloText.innerText);
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, "your-key");
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function showPrefs() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);  
} 

function hidePrefs() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    back.style.display="none"; 
    front.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0); 
	Go();
} 

/* Hiding and showing the info button   */
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
